<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>cosmetics &#8212; pydecha 0.3+13.g1a2fafa.dirty documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b3523f8e" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=cb25574f" />
    <script src="../../_static/documentation_options.js?v=2fb7d489"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Acronyms" href="../../about/acronyms.html" />
    <link rel="prev" title="gain" href="gain.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="module-cmos.cosmetics.cosmetics_acquisition">
<span id="cosmetics"></span><h1>cosmetics<a class="headerlink" href="#module-cmos.cosmetics.cosmetics_acquisition" title="Link to this heading">¶</a></h1>
<section id="cosmetics-acquisition-module">
<h2>cosmetics acquisition module<a class="headerlink" href="#cosmetics-acquisition-module" title="Link to this heading">¶</a></h2>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Author</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Benoit Serra</p></td>
<td><p>cosmetics</p></td>
<td><p>%(date)</p></td>
</tr>
</tbody>
</table>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Contributor</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Name</p></td>
<td><p>filename</p></td>
<td><p>06/21/2019</p></td>
</tr>
</tbody>
</table>
<p>This is a documentation template for the cosmetics acquisition module.
Documentation is generated going into docs/ and typing ‘make html’</p>
<p>This module can be found in pydecha/modules/cosmetics/cosmetics_acquisition.py.
Please modify the docstrings accordingly to provide the users a simple and
detailed explanation of your algorithm for this module.</p>
<section id="table-examples">
<h3>Table examples<a class="headerlink" href="#table-examples" title="Link to this heading">¶</a></h3>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Table entries</p></th>
<th class="head"><p>Table values</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Entry 1</p></td>
<td><p>Value 1</p></td>
</tr>
<tr class="row-odd"><td><p>Entry 2</p></td>
<td><p>Value 2</p></td>
</tr>
<tr class="row-even"><td><p>Entry 3</p></td>
<td><p>Value 3</p></td>
</tr>
<tr class="row-odd"><td><p>Entry 4</p></td>
<td><p>Value 4</p></td>
</tr>
<tr class="row-even"><td><p>Entry 5</p></td>
<td><p>Value 5</p></td>
</tr>
</tbody>
</table>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Header row, column 1
(header rows optional)</p></th>
<th class="head"><p>Header 2</p></th>
<th class="head"><p>Header 3</p></th>
<th class="head"><p>Header 4</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>body row 1, column 1</p></td>
<td><p>column 2</p></td>
<td><p>column 3</p></td>
<td><p>column 4</p></td>
</tr>
<tr class="row-odd"><td><p>body row 2</p></td>
<td colspan="3"><p>Cells may span columns.</p></td>
</tr>
<tr class="row-even"><td><p>body row 3</p></td>
<td rowspan="2"><p>Cells may
span rows.</p></td>
<td colspan="2" rowspan="2"><ul class="simple">
<li><p>Table cells</p></li>
<li><p>contain</p></li>
<li><p>body elements.</p></li>
</ul>
</td>
</tr>
<tr class="row-odd"><td><p>body row 4</p></td>
</tr>
<tr class="row-even"><td><p>body row 5</p></td>
<td colspan="2"><p>Cells may also be
empty: <code class="docutils literal notranslate"><span class="pre">--&gt;</span></code></p></td>
<td></td>
</tr>
</tbody>
</table>
</section>
<section id="code-example">
<h3>Code example<a class="headerlink" href="#code-example" title="Link to this heading">¶</a></h3>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">sys</span>

<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Hello world...&#39;</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="useful-links">
<h3>Useful links<a class="headerlink" href="#useful-links" title="Link to this heading">¶</a></h3>
<p>ReadTheDocs documentation
<a class="reference external" href="https://sphinx-rtd-theme.readthedocs.io/en/latest/index.html">https://sphinx-rtd-theme.readthedocs.io/en/latest/index.html</a></p>
<div class="admonition-todo admonition" id="id1">
<p class="admonition-title">Todo</p>
<p>Write the documentation for cosmetics</p>
</div>
</section>
</section>
<dl class="py class">
<dt class="sig sig-object py" id="cmos.cosmetics.cosmetics_acquisition.module">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">cmos.cosmetics.cosmetics_acquisition.</span></span><span class="sig-name descname"><span class="pre">module</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">module_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yaml_dict</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#cmos.cosmetics.cosmetics_acquisition.module" title="Link to this definition">¶</a></dt>
<dd><p>Example class with documented types</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>None</strong> – analysis module initialize with the parameters from the yaml conf. file</p>
</dd>
<dt class="field-even">Return None<span class="colon">:</span></dt>
<dd class="field-even"><p>The return value. Nothing for now…</p>
</dd>
</dl>
</dd></dl>

<section id="cosmetics-analysis-module">
<span id="module-cmos.cosmetics.cosmetics_analysis"></span><h2>cosmetics analysis module<a class="headerlink" href="#cosmetics-analysis-module" title="Link to this heading">¶</a></h2>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Author</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Benoit Serra</p></td>
<td><p>cosmetics</p></td>
<td><p>Thu Jul  4 11:47:56 2019</p></td>
</tr>
</tbody>
</table>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Contributor</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Elizabeth Georges</p></td>
<td><p>H4RG-Analysis_Cosmetics.ipynb</p></td>
<td><p>07/04/2019</p></td>
</tr>
</tbody>
</table>
<p>This module can be found in pydecha/modules/cosmetics/cosmetics_analysis.py.
Please modify the docstrings accordingly to provide the users a simple and
detailed explanation of your algorithm for this module.</p>
<section id="id2">
<h3>Cosmetics<a class="headerlink" href="#id2" title="Link to this heading">¶</a></h3>
<p>The cosmetics of the detector is an elegant way to say “pixels that don’t behaves
properly”. This group several types of pixels:</p>
<dl class="simple">
<dt>Disconnected/Dead pixels</dt><dd><p>Pixels that do not convert photon to photo_generated carriers</p>
</dd>
<dt>Hot/Noisy pixels</dt><dd><p>Pixels that always displays a higher than average signal of the pixel</p>
</dd>
<dt>Low QE pixels</dt><dd><p>No description yet</p>
</dd>
<dt>Cosmic/RTN pixels</dt><dd><p>Pixels that have been hit by cosmics while integrating signal or that
are subject to Random Telegraphic Noise.</p>
</dd>
</dl>
</section>
<section id="data-acquisition">
<h3>Data acquisition<a class="headerlink" href="#data-acquisition" title="Link to this heading">¶</a></h3>
<p>This script exists to analyze the cosmetics data taken using the following
procedure:</p>
<dl class="simple">
<dt>Noise data:</dt><dd><p>Double correlated: MINDIT, NDIT = 50, store INT and STDEV frame. Take 5 data set.</p>
</dd>
<dt>Connection data:</dt><dd><p>Uncorrelated: MINDIT, NDIT = 10, store INT frame. Take 1 frame at 250 mV bias and a second at 300 mV bias (all other parameters the same) (repeat 5x)</p>
</dd>
<dt>Dark current data:</dt><dd><p>Double correlated: DIT = 60s, NDIT = 10, store INT and STDEVframe. Take 5 data sets.</p>
</dd>
</dl>
</section>
<section id="computation">
<h3>Computation<a class="headerlink" href="#computation" title="Link to this heading">¶</a></h3>
<ol class="arabic simple">
<li><p>Start with a badpix map that is 4096 x 4096 px with a value of 0 everywhere.</p></li>
<li><p>Flag all disconnected pixels:</p></li>
</ol>
<blockquote>
<div><ol class="loweralpha simple">
<li><p>Take 250mV bias frame and subtract it from the 300mV bias frame to produce a difference frame.</p></li>
<li><p>Make a histogram of the pixel values in the difference frame. Record center and sigma. (Alternatively, use median and stddev of this frame, which will be close enough for this.)</p></li>
<li><p>Any pixels in difference frame within 5 sigma of 0 are disconnected. Set to 2 in badpix map (note - need to sanity check this to ensure that the center of the distribution is &gt;10 sigma from zero for this threshold to make sense!)</p></li>
</ol>
</div></blockquote>
<ol class="arabic simple" start="3">
<li><p>Flag all noisy/RTN pixels:</p></li>
</ol>
<blockquote>
<div><ol class="loweralpha simple">
<li><p>Make a histogram of the pixel values in the “Noise STDDEV frame” and fit a skewed gaussian. Record center and sigma. (Alternatively, use median and stddev of this frame, which will be close enough for this.)</p></li>
<li><p>Any pixel with value in the “Noise STDDEV frame” &gt; 5 sigma from center in all 5 datasets = noisy. Set to 4 in badpix map.</p></li>
<li><p>Any pixel with value in the “Noise STDDEV frame” &gt; 5 sigma from center in some but not all datasets = RTN. Set to 8 in badpix map.</p></li>
</ol>
</div></blockquote>
<ol class="arabic simple" start="4">
<li><p>Flag all hot pixels:</p></li>
</ol>
<blockquote>
<div><ol class="loweralpha simple">
<li><p>Make a histogram of the pixel values in the “Dark INT frame” and fit a skewed gaussian. Record center and sigma. (Alternatively, use median and stddev of this frame, which will be close enough for this.)</p></li>
<li><p>Any pixels with value in all 5 data sets of “DARK INT frame” &gt;5 sigma center = hot. Set to 16 in badpix map. (Note - since we expect ~60e- background, this will only catch REALLY hot pixels, e.g. pixels with &gt; ~100 e- dark current in a 1 minute exposure.)</p></li>
</ol>
</div></blockquote>
<ol class="arabic simple" start="5">
<li><p>Optional: flag cosmics:</p></li>
</ol>
<blockquote>
<div><ol class="loweralpha simple">
<li><p>Make a histogram of the pixel values in the “Dark INT frame” and fit a skewed gaussian. Record center and sigma. (Alternatively, use median and stddev of this frame, which will be close enough for this.)</p></li>
<li><p>Any pixels with value in some but not all datasets of “DARK INT frame” &gt;5 sigma center = cosmics. Set to 32 in badpix map.</p></li>
</ol>
</div></blockquote>
<ol class="arabic simple" start="6">
<li><p>Create an overall (binary) bad pixel image for display purposes- display an image with black = badpix, white = goodpix.</p></li>
</ol>
<p>Note: values of badpix and their meanings may change later!</p>
</section>
<section id="plots">
<h3>Plots<a class="headerlink" href="#plots" title="Link to this heading">¶</a></h3>
<div class="admonition-todo admonition" id="id4">
<p class="admonition-title">Todo</p>
<div class="admonition-todo admonition" id="id3">
<p class="admonition-title">Todo</p>
<p>Need to put proper plots for the cosmetics</p>
</div>
</div>
</section>
</section>
<dl class="py class">
<dt class="sig sig-object py" id="cmos.cosmetics.cosmetics_analysis.module">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">cmos.cosmetics.cosmetics_analysis.</span></span><span class="sig-name descname"><span class="pre">module</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">module_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yaml_dict</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#cmos.cosmetics.cosmetics_analysis.module" title="Link to this definition">¶</a></dt>
<dd><p>Cosmetics analysis block</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>(</strong><strong>str</strong><strong>)</strong> (<em>module_name</em>) – Name of the module as string.</p></li>
<li><p><strong>(</strong><strong>dict</strong><strong>)</strong> (<em>yaml_dict</em>) – full dictionnary of the config file.</p></li>
</ul>
</dd>
<dt class="field-even">Return clean_output()<span class="colon">:</span></dt>
<dd class="field-even"><p>a cleaned dictionnary with the parameters saved</p>
</dd>
</dl>
<p>The cosmetics analysis requires the following parameters in the configuration
file:</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>(</strong><strong>str</strong><strong>)</strong> (<em>data_path</em>) – absolute path of where the data is.</p></li>
<li><p><strong>(</strong><strong>int</strong><strong>)</strong> (<em>cutoff</em>) – cutoff value for the outliers (generally cutoff*std).</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">pydecha</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Introduction</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../introduction/pydecha.html">PYDECHA</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../introduction/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../introduction/first_steps.html">Getting started</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Characterization modules</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../new_module.html">Tutorial for new module</a></li>
<li class="toctree-l1"><a class="reference internal" href="../modules_ccd.html">Modules CCD</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../modules_cmos.html">Modules CMOS</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="monitoring.html">monitoring</a></li>
<li class="toctree-l2"><a class="reference internal" href="noise.html">noise</a></li>
<li class="toctree-l2"><a class="reference internal" href="preampgain.html">preampgain</a></li>
<li class="toctree-l2"><a class="reference internal" href="cellgain.html">cellgain</a></li>
<li class="toctree-l2"><a class="reference internal" href="gain.html">gain</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">cosmetics</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#cosmetics-acquisition-module">cosmetics acquisition module</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#table-examples">Table examples</a></li>
<li class="toctree-l4"><a class="reference internal" href="#code-example">Code example</a></li>
<li class="toctree-l4"><a class="reference internal" href="#useful-links">Useful links</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#cmos.cosmetics.cosmetics_acquisition.module"><code class="docutils literal notranslate"><span class="pre">module</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#cosmetics-analysis-module">cosmetics analysis module</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#id2">Cosmetics</a></li>
<li class="toctree-l4"><a class="reference internal" href="#data-acquisition">Data acquisition</a></li>
<li class="toctree-l4"><a class="reference internal" href="#computation">Computation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#plots">Plots</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#cmos.cosmetics.cosmetics_analysis.module"><code class="docutils literal notranslate"><span class="pre">module</span></code></a></li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">About</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../about/acronyms.html">Acronyms</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/changelog.html">Change log</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/faq.html">FAQ</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/references.html">References</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../modules_cmos.html">Modules CMOS</a><ul>
      <li>Previous: <a href="gain.html" title="previous chapter">gain</a></li>
      <li>Next: <a href="../../about/acronyms.html" title="next chapter">Acronyms</a></li>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2019, European Southern Observatory.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../../_sources/modules/modules_cmos/cosmetics.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>